package geo;

import geo.basics.Point;
import java.util.Scanner;

public class Circle {

    public static double delta = 0.01;  

    public Point cp = new Point();
    private double r = 1;
    private double area = r*r*Math.PI;

    public static Circle readCircle(Scanner sc) {
        return new Circle(Point.readPoint(sc), sc.nextDouble());
    }
  
    public Circle(Point p, double r) {
        this.cp = p;
        setR(r);
    }

    public Circle(int x, int y, double r) {
        this(new Point(x,y), r);
    }

    public Circle(double r) {
        this(new Point(), r);
    }

    public Circle() {
        this(1);
    }

    public String toString() {
        return "cp:" + cp.toString() + " r:" + r;
    }

    public void setR(double r) {
        this.r = r;
        area = r*r*Math.PI;
    }

    public double getR() {
        return r;
    }

    public double getArea() {
        return area;
    }

    public void shift(int dx, int dy) {
        cp.shift(dx, dy);
    }

    public void enlarge(double factor) {
        r *= factor;
        area = r*r*Math.PI;
    }

    public void toCenterPoint(Point p) {
        cp = p;
    }

    public boolean isLieOn(Point p) {
        return delta > Math.abs(Point.distance(cp, p) - r);
    }
}
