package geo.basics;

import java.util.Scanner;

/**
 * Movable Point in a two-dimensional coordinate-system.
 */
public class Point {

    /** The first coordinate of the point.*/
    public int x;

    /** The second coordinate of the point.*/
    public int y;
    
    public Point(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public Point() {
        this(1,1);
        //this.x = 1;
        //this.y = 1;
    }

    public static Point readPoint(Scanner sc) {
        int x = sc.nextInt();
        int y = sc.nextInt();
        return new Point(x, y);
    }

    /**
     * Calculates the distance of the given two points.
     * @param p1 The first point.
     * @param p2 The first point.
     * @return The calculated distance.
     */
    public static double distance(Point p1, Point p2) {
        return Math.hypot(p1.x-p2.x,p1.y-p2.y); 
    }

    public void shift(int x, int y) {
        this.x += x;
        this.y += y;
    }

    public double distance(Point p) {
        return distance(this, p);
    }

    public String toString() {
        return "(" + x + "," + y + ")";
    }
	
	public void println(){
		System.out.println(this.toString());
	}

}